MIN_USER = 3
MIN_PASS = 7

class String
  def remove_non_ascii(replacement='')
    n=self.split("")
    self.slice!(0..self.size)
    n.each { |b|
     if b.ord < 48 || b.ord > 57 && b.ord < 65 || b.ord > 90 && b.ord < 97 || b.ord > 122 then
       self.concat(replacement)
     else
       self.concat(b)
     end
    }
    self.to_s
  end

  def test_password()
    symbol = false
    number = false
    capital= false
    regular= false
    all_valid= true
    n=self.split("")
    self.slice!(0..self.size)
    n.each { |b|
     # test symbols
     if b.ord > 32 && b.ord < 48 || b.ord > 58 && b.ord < 65 || b.ord > 91 && b.ord < 97 || b.ord > 123 && b.ord < 126 then
       symbol = true
     # test capital letters
     elsif b.ord > 65 && b.ord < 91 then
       capital = true
     # test numbers
     elsif b.ord > 47 && b.ord < 58 then
       number = true
     # test regular alphabet
     elsif b.ord > 96 && b.ord < 123 then
       regular = true
     else
       # com character out of the acceptable ranges
       all_valid = false
     end
    }
    if symbol && capital && number && regular && all_valid
      return true
    end
  end
end

def check_string_sanity(album)
  album.gsub!(/^\//,'')
  album.gsub!(/^#{$config['ALBUM_URL']}/,'')
  album.gsub!(/^\//,'')
  folders=album.split("/")
  r_folders=''
  folders.each do |f|
    r_folders= [r_folders,f.remove_non_ascii].join("/")
  end
  r_folders = r_folders.gsub!(/^\//,'')
  return r_folders
end

def load_gem(gem_name)
  found_gem = false
  begin
    found_gem = Gem::Specification.find_by_name(gem_name)
  rescue Gem::LoadError
    puts "Could not find gem '#{gem_name}'. Please run 'gem install #{gem_name}' as user #{ENV["USER"]}"
    exit 1
  else
    require(gem_name)
  end
end

CA_PHOSEUM = "-----BEGIN CERTIFICATE-----
MIID9zCCAt+gAwIBAgIJAMKPNoBSyDt9MA0GCSqGSIb3DQEBCwUAMIGRMQswCQYD
VQQGEwJOTDEVMBMGA1UECAwMWnVpZC1Ib2xsYW5kMSAwHgYDVQQKDBdTcGVjdHJv
TkVUIEhhY2tpbmcgQ29ycDEMMAoGA1UECwwDSUNUMRYwFAYDVQQDDA0qLnNjaWVu
Y2UubmV0MSMwIQYJKoZIhvcNAQkBFhRzcGVjdHJvbWFuQHlhaG9vLmNvbTAeFw0x
NTEwMDUxNDQ1MjJaFw00NTA5MjcxNDQ1MjJaMIGRMQswCQYDVQQGEwJOTDEVMBMG
A1UECAwMWnVpZC1Ib2xsYW5kMSAwHgYDVQQKDBdTcGVjdHJvTkVUIEhhY2tpbmcg
Q29ycDEMMAoGA1UECwwDSUNUMRYwFAYDVQQDDA0qLnNjaWVuY2UubmV0MSMwIQYJ
KoZIhvcNAQkBFhRzcGVjdHJvbWFuQHlhaG9vLmNvbTCCASIwDQYJKoZIhvcNAQEB
BQADggEPADCCAQoCggEBAJeWOJx0h1yzLdPx0tYv9IP2YtUzkGYonM5X8hEgOkRh
jxL+WwSWvaHjGUkvowzveh5gEeRAET+TkGslxG8yefaFJ9J2+0/83gqcd4A2iFpd
wp8aHqFs7Qg8Y4TIY8Ww1OTeXqqxuRnsn3oF5HS8U2W5atkd7kpdUOYPw8siSuQV
xVKoDQMVo6ZE+RPspRRuEwnyk3zQHnaEcgCGtssVFuvhsObCB55rWMafxP4UbGvX
WzqxmVcHDAgHXl/neAhg1EPhrRqYDf6pIo207eWvuqAVCtFQfXf4YtzuCml7GHrM
TGCRDf/g9KBdtvispd4VCVKEUFKx3okqQIzW3dsXPy0CAwEAAaNQME4wHQYDVR0O
BBYEFF6zq/J7W2EIi41YOsDoo/AmMVZYMB8GA1UdIwQYMBaAFF6zq/J7W2EIi41Y
OsDoo/AmMVZYMAwGA1UdEwQFMAMBAf8wDQYJKoZIhvcNAQELBQADggEBACgmgSHr
YffpiSMbZUzMtC8rcexeoMDw1X9UobdanPU0FBgYruj4yjdoEIsrlaXTgHf3PEki
NWShCsRCAOZIPQkEzwN/0wom+JhB6xbURPiwSrG6TEhz8YFBn94eiHz1OycHxpf6
QD85+tN847Q0V0KXmrwoQkIEVXT4of/NRhzHQlCkHuDoT5oQdkN7W3cZFqWkXGRM
t6fZ03zeXlSH5HLmysm2DU2uB182orzWYABdwLmINR44isw8/6RS1mx8BGI+08l8
sfxrWyWaDOPnwLWbFWTqnv94w4frHyHoRY+lBPZ4DT8MAFxYXI5Rf/hBUGav5NM4
yivphjaSSCTRqyE=
-----END CERTIFICATE-----"

def load_config(who)
  load_gem('yaml')
  if who == "api"
    local_dir=Dir.pwd
    home_cfg=File.expand_path("#{local_dir}/cfg")
    file_to_load = [home_cfg,"phoseum-api-config.yml"].join('/')
    if !Dir.exist?(home_cfg)
      gen_config(who)
      puts "New configuration was generated at #{file_to_load}. Please complete missing information and run again"
      exit 1
    end
    if !File.file?(file_to_load)
      puts "API CFG Not found: #{file_to_load} "
      exit 1
    end
  elsif who == "cli"
    home_cfg=File.expand_path('~/.phoseum/')
    file_to_load = [home_cfg,"cli-config.yml"].join('/')
    if !Dir.exist?(home_cfg)
      gen_config(who)
      puts "New configuration was generated at #{file_to_load}. Please complete missing information and run again"
      exit 1
    end
    if !File.file?(file_to_load)
      puts "CLI CFG Not found: #{file_to_load} "
      exit 1
    end
  else
    puts "Not sure which configuration to load. Abort."
    exit 1
  end

  begin
    config_data = YAML.load_file(file_to_load)
    puts "Opening configuration from #{file_to_load}" if config_data['DEBUG']
  rescue
    puts "Failed loading configuration from #{file_to_load}"
    exit 1
  end
  return config_data
end

def gen_config(who)

  local_config={}
  file_to_write=''

  case who
  when "cli"
    local_config['SERVERURL']=""
    local_config['DEBUG']=false
    local_config['PORT']=2207
    local_config['CALL_TIMEOUT']=120
    local_config['DEFAULT_SECRET']="copy-secret-from-server"
    local_config['TOKEN']="make-a-successful-login"

    home_cfg=File.expand_path('~/.phoseum/')
    local_config['CA_TRUST']=[home_cfg,"CA-PHOSEUM"].join('/')

    if !Dir.exist?(home_cfg)
      Dir.mkdir(home_cfg)
      File.open("#{home_cfg}/CA-PHOSEUM", 'w') do |ca|
        ca.write(CA_PHOSEUM)
      end
    end
    file_to_write = [home_cfg,"cli-config.yml"].join('/')
    puts "Creating config at #{file_to_write}"

  when "api"
    local_config['THREADED']=false
    local_dir=Dir.pwd
    local_config['BASEALBUM']="#{local_dir}/Albums"
    local_config['ALBUM_URL']="Albums"
    local_config['STORE_DIR']="#{local_dir}"
    local_config['DEBUG']=true
    local_config['PORT']=2207
    local_config['EXT_URL']=""
    local_config['MAX_IMG_SIZE']=50000000
    local_config['RESIZE']="640x640"
    local_config['RESAMPLE']="72x72"
    local_config['CALL_TIMEOUT']=120
    home_cfg="#{local_dir}/cfg"
    if !Dir.exist?(home_cfg)
      Dir.mkdir(home_cfg)
    end
    file_to_write = [home_cfg,"phoseum-api-config.yml"].join('/')
    puts "Creating config at #{file_to_write}"

    new_secret = SecureRandom.base64(32)
    local_config['DEFAULT_SECRET'] = new_secret
    puts "\nGenerating new secret: #{new_secret}"

  end

  File.open(file_to_write, 'w') do |f|
    f.write(Psych.dump(local_config))
  end
  return true

end
